# Contributing to redux-saga
Contributing to redux-saga isn't limited to just filing bugs, users are more than welcomed to make suggestions, report any issue they may find, and make pull requests to help make redux-saga better.

## Filing a bug
When filing a bug, please follow the provided template:

```
### Description of the bug/issue

# Steps to reproduce the bug/issue

1.
2.
3.
...

# Your results

# The expected reults

# System information
```

**Please be sure to include a way to reproduce a given issue, as they can be very helpful and make quick work of coming up with a fix! You can also make completely separate repos for reproduction of issues, or use [Code Sandbox](https://codesandbox.io/). That way, the issue is sandboxed and can be worked on as is.**

## Working on redux-saga
### Prerequisites
* [Git](https://git-scm.com/)
* Latest version of [Node.js](https://nodejs.org/en/)

### Getting redux-saga
1. Fork a copy of our repo
2. Open up Git in an environment of your choice
3. Run the following

```
$ git clone https://github.com/YOUR-GITHUB-PROFILE-NAME/redux-saga.git
$ cd redux-saga
$ npm run bootstrap
$ npm test
```

### Using branches
When working on any issue on Github, it's a good practice to make branches that are specific to the issue you're currently working on. For instance, if you're working on an issue with a name like "NAME OF ISSUE #1234", from the master branch run the following code: `git checkout -b Issue#1234`. In doing so, you'll be making a branch that specifically identifies the issue at hand, and moves you right into it with the `checkout` flag. This keeps your main (master) repository clean and your personal workflow cruft out of sight when making a pull request. 

### Finding issues to fix
After you've forked and cloned our repo, you can find issues to work on by heading over to our [issues list](https://github.com/redux-saga/redux-saga/issues). We advise looking at the issues with the labels [help wanted](https://github.com/redux-saga/redux-saga/issues?q=is%3Aissue+is%3Aopen+label%3A%22help+wanted%22) or [good first issue](https://github.com/redux-saga/redux-saga/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22), as they will help you get familiar with the redux-saga code. 

### Rules of the discussions
Remember to be very clear and transparent when discussing any issue in the discussions boards. We ask that you keep the language to English and keep on track with the issue at hand. Lastly, please be respectful of our fellow contributors and keep an exemplary level of professionalism at all times.  